from sprite import *
from act import *
from spr import *

def Spr2Sprite(spr):
    sprite = Sprite()
    sprite.ntextures = spr.nImages+spr.nRgbaImages
    sprite.nImages = spr.nImages
    sprite.nRgbaImages = spr.nRgbaImages
    sprite.texsize = []
    sprite.images = []
    sprite.rgbaImages = []
    sprite.palR = []
    sprite.palG = []
    sprite.palB = []
    sprite.palA = []
    sprite.pal = spr.pal
    
    for i in range(256):
        sprite.palR.append(float(ord(spr.pal[4*i])/255.0))
        sprite.palG.append(float(ord(spr.pal[4*i+1])/255.0))
        sprite.palB.append(float(ord(spr.pal[4*i+2])/255.0))
        sprite.palA.append(float(ord(spr.pal[4*i+3])/255.0))

    for i in range(spr.nImages):
        sizeX, sizeY, indexImage = spr.images[i]
        sprite.images.append((sizeX, sizeY, indexImage))
    for i in range(spr.nRgbaImages):
        sizeX, sizeY, data = spr.rgbaImages[i]
        sprite.rgbaImages.append((sizeX, sizeY, data))

    sprite.animations = []
    return sprite
    

def SprAct2Sprite(spr, act):
    sprite = Sprite()
    sprite.ntextures = spr.nImages+spr.nRgbaImages
    sprite.nImages = spr.nImages
    sprite.nRgbaImages = spr.nRgbaImages
    sprite.texsize = []
    sprite.images = []
    sprite.rgbaImages = []
    sprite.palR = []
    sprite.palG = []
    sprite.palB = []
    sprite.palA = []
    sprite.timescale = act.timescale

    sprite.pal = spr.pal

    for i in range(256):
        sprite.palR.append(float(ord(spr.pal[4*i])/255.0))
        sprite.palG.append(float(ord(spr.pal[4*i+1])/255.0))
        sprite.palB.append(float(ord(spr.pal[4*i+2])/255.0))
        sprite.palA.append(float(ord(spr.pal[4*i+3])/255.0))

    for i in range(spr.nImages):
        sizeX, sizeY, indexImage = spr.images[i]
        sprite.images.append((sizeX, sizeY, indexImage))
    for i in range(spr.nRgbaImages):
        sizeX, sizeY, data = spr.rgbaImages[i]
        sprite.rgbaImages.append((sizeX, sizeY, data))
        
    sprite.animations = []
    for animation in act.animations:
        nframes, frames = animation
        newframes = []
        for frame in frames:
            nsubframes, subframes, isextrainfo, extraX, extraY = frame

            newframe = {}
            newframe['extraX'] = extraX
            newframe['extraY'] = extraY
            newframe['subframes'] = []

            for subframe in subframes:
                x, y, imageNum, direction, (cr, cg, cb, ca), scaleX, scaleY, withsize, givensizeX, givensizeY, rgba = subframe

                newsubframe = {}
                newsubframe['x'] = x
                newsubframe['y'] = y
                newsubframe['imageNum'] = imageNum
                newsubframe['direction'] = direction
                newsubframe['red'] = cr
                newsubframe['green'] = cg
                newsubframe['blue'] = cb
                newsubframe['alpha'] = ca
                newsubframe['scaleX'] = scaleX
                newsubframe['scaleY'] = scaleY
                newsubframe['sizeX'] = sizeX
                newsubframe['sizeY'] = sizeY
                newsubframe['rgba'] = rgba

                newframe['subframes'].append(newsubframe)

            newframes.append(newframe)
        sprite.animations.append(newframes)
    
    return sprite

def Sprite2Act(sprite):
    act = Act('', empty=1)
    act.timescale = sprite.timescale
    act.nanimations = len(sprite.animations)
    act.animations = []
    for newframes in sprite.animations:
        nframes = len(newframes)
        frames = []
        for newframe in newframes:
            extraX = newframe['extraX']
            extraY = newframe['extraY']

            if extraX == 99999 and extraY == extraX:
                isextrainfo = 0
            else:
                isextrainfo = 1

            nsubframes = len(newframe['subframes'])

            subframes = []
            for subframe in newframe['subframes']:
                subframes.append((subframe['x'], subframe['y'], subframe['imageNum'], subframe['direction'],
                                 (subframe['red'], subframe['green'], subframe['blue'], subframe['alpha']),
                                 subframe['scaleX'], subframe['scaleY'], 0, 0, 0, subframe['rgba']))

            frames.append((nsubframes, subframes, isextrainfo, extraX, extraY))
        act.animations.append((nframes, frames))
    return act
